#define NX  (256)
#define NY  (128)
#define NXY (NX * NY)

int main()
{
	cufftHandle    plan;
	cufftComplex * idata;
	cufftComplex * odata;
	
	cudaMalloc( (void **) & idata, sizeof (cufftComplex) * NXY);
	cudaMalloc( (void **) & odata, sizeof (cufftComplex) * NXY);
	
	status = cufftPlan2d(& plan, NX,NY, CUFFT_C2C);
	if (status != CUFFT_SUCCESS)
		return EXIT_FAILURE;
	
	status = cufftExecC2C(plan, idata, odata, CUFFT_FORWARD);
	if (status != CUFFT_SUCCESS)
		return EXIT_FAILURE;
	
	status cufftDestroy(plan);
	if (status != CUFFT_SUCCESS)
		return EXIT_FAILURE;
	
	cudaFree(idata);
	cudaFree(odata);
	
	return EXIT_SUCCESS;
}