#include <thrust/device_vector.h>
#include <thrust/transform.h>
#include <thrust/sequence.h>
#include <thrust/copy.h>
#include <thrust/fill.h>
#include <thrust/replace.h>
#include <thrust/functional.h>
#include <iostream>

int main(void)
{
    thrust::device_vector<int> X(10);
    thrust::device_vector<int> Y(10);
    thrust::device_vector<int> Z(10);

    // remplit X par des valeurs de 1  10
    thrust::sequence(X.begin(), X.end());

    // Y = -X
    thrust::transform(X.begin(), X.end(), Y.begin(), thrust::negate<int>());

    // remplit Z avec des 2
    thrust::fill(Z.begin(), Z.end(), 2);

    // Y = X mod 2
    thrust::transform(X.begin(), X.end(), Z.begin(), Y.begin(), thrust::modulus<int>());

    // remplace tous les 1 de Y par  10
    thrust::replace(Y.begin(), Y.end(), 1, 10);

    // copie le contenu de Y dans le flux de sortie cout
    thrust::copy(Y.begin(), Y.end(), std::ostream_iterator<int>(std::cout, "\n"));

    return 0;
}